ON_PolyEdgeSegment Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_polyedgecurve.h>`

Inheritance diagram for ON_PolyEdgeSegment:

## Public Member Functions

| ON_PolyEdgeSegment ()
| ~ON_PolyEdgeSegment ()
void | DestroyRuntimeCache (bool bDelete=true)
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON_BOOL32 | IsClosed () const
ON_Curve * | DuplicateCurve () const
bool | Create (const ON_BrepTrim *trim, const ON_UUID &object_id)
bool | Create (const ON_Curve *curve, const ON_UUID &object_id)
const ON_BrepEdge * | Edge () const
const ON_BrepTrim * | Trim () const
const ON_Brep * | Brep () const
const ON_BrepFace * | Face () const
const ON_Surface * | Surface () const
ON_Surface::ISO | IsoType () const
double | EdgeParameter (double t) const
bool | ReversedEdgeDir () const
bool | ReversedTrimDir () const
ON_Interval | EdgeDomain () const
ON_Interval | TrimDomain () const
Public Member Functions inherited from ON_CurveProxy
| ON_CurveProxy ()
| ON_CurveProxy (const ON_CurveProxy &)
| ON_CurveProxy (const ON_Curve *)
| ON_CurveProxy (const ON_Curve *, ON_Interval)
ON_CurveProxy & | operator= (const ON_CurveProxy &)
virtual | ~ON_CurveProxy ()
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
void | SetProxyCurve (const ON_Curve *real_curve)
void | SetProxyCurve (const ON_Curve *real_curve, ON_Interval real_curve_subdomain)
const ON_Curve * | ProxyCurve () const
bool | SetProxyCurveDomain (ON_Interval proxy_curve_subdomain)
ON_Interval | ProxyCurveDomain () const
bool | ProxyCurveIsReversed () const
double | RealCurveParameter (double t) const
double | ThisCurveParameter (double real_curve_parameter) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
ON_Interval | Domain () const
ON_BOOL32 | SetDomain (double t0, double t1)
bool | SetDomain (ON_Interval domain)
int | SpanCount () const
ON_BOOL32 | GetSpanVector (double *) const
int | Degree () const
ON_BOOL32 | GetParameterTolerance (double, double *, double *) const
ON_BOOL32 | IsLinear (double=ON_ZERO_TOLERANCE) const
int | IsPolyline (ON_SimpleArray< ON_3dPoint > *pline_points=NULL, ON_SimpleArray< double > *pline_t=NULL) const
ON_BOOL32 | IsArc (const ON_Plane *=NULL, ON_Arc *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsPlanar (ON_Plane *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsInPlane (const ON_Plane &, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsPeriodic (void) const
bool | GetNextDiscontinuity (ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse ()
ON_BOOL32 | Evaluate (double, int, int, double *, int=0, int *=0) const
ON_BOOL32 | Trim (const ON_Interval &domain)
ON_BOOL32 | Split (double t, ON_Curve *&left_side, ON_Curve *&right_side) const
int | GetNurbForm (ON_NurbsCurve &, double=0.0, const ON_Interval *=NULL) const
int | HasNurbForm () const
ON_BOOL32 | GetCurveParameterFromNurbFormParameter (double, double *) const
ON_BOOL32 | GetNurbFormParameterFromCurveParameter (double, double *) const
Public Member Functions inherited from ON_Curve
| ON_Curve ()
| ON_Curve (const ON_Curve &)
ON_Curve & | operator= (const ON_Curve &)
virtual | ~ON_Curve ()
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
ON::object_type | ObjectType () const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | GetDomain (double *t0, double *t1) const
bool | SetDomain (ON_Interval domain)
virtual ON_BOOL32 | ChangeClosedCurveSeam (double t)
virtual bool | ChangeDimension (int desired_dimension)
virtual ON_BOOL32 | GetSpanVectorIndex (double t, int side, int *span_vector_index, ON_Interval *span_domain) const
bool | IsArcAt (double t, const ON_Plane *plane=0, ON_Arc *arc=0, double tolerance=ON_ZERO_TOLERANCE, double *t0=0, double *t1=0) const
virtual bool | IsEllipse (const ON_Plane *plane=NULL, ON_Ellipse *ellipse=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsClosable (double tolerance, double min_abs_size=0.0, double min_rel_size=10.0) const
virtual ON_BOOL32 | SetStartPoint (ON_3dPoint start_point)
virtual ON_BOOL32 | SetEndPoint (ON_3dPoint end_point)
ON_3dPoint | PointAt (double t) const
ON_3dPoint | PointAtStart () const
ON_3dPoint | PointAtEnd () const
ON_3dVector | DerivativeAt (double t) const
ON_3dVector | TangentAt (double t) const
ON_3dVector | CurvatureAt (double t) const
ON_BOOL32 | FrameAt (double t, ON_Plane &plane) const
ON_BOOL32 | EvPoint (double t, ON_3dPoint &point, int side=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, int side=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, ON_3dVector &second_derivative, int side=0, int *hint=0) const
ON_BOOL32 | EvTangent (double t, ON_3dPoint &point, ON_3dVector &tangent, int side=0, int *hint=0) const
ON_BOOL32 | EvCurvature (double t, ON_3dPoint &point, ON_3dVector &tangent, ON_3dVector &kappa, int side=0, int *hint=0) const
bool | FirstSpanIsLinear (double min_length, double tolerance) const
bool | LastSpanIsLinear (double min_length, double tolerance) const
bool | FirstSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
bool | LastSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
virtual bool | Extend (const ON_Interval &domain)
ON_NurbsCurve * | NurbsCurve (ON_NurbsCurve *pNurbsCurve=NULL, double tolerance=0.0, const ON_Interval *subdomain=NULL) const
void | DestroyCurveTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

ON_UUID | m_object_id
ON_COMPONENT_INDEX | m_component_index
ON_Interval | m_edge_domain
ON_Interval | m_trim_domain
const void * | m_parent_object
const ON_Brep * | m_brep
const ON_BrepTrim * | m_trim
const ON_BrepEdge * | m_edge
const ON_BrepFace * | m_face
const ON_Surface * | m_surface

## Friends

class | ON_PolyEdgeCurve

## Additional Inherited Members

Protected Member Functions inherited from ON_Curve
bool | ParameterSearch (double t, int &index, bool bEnableSnap, const ON_SimpleArray< double > &m_t, double RelTol=ON_SQRT_EPSILON) const

## Detailed Description

Definition at line 142 of file opennurbs_polyedgecurve.h.

## Constructor & Destructor Documentation

## ON_PolyEdgeSegment()

ON_PolyEdgeSegment::ON_PolyEdgeSegment | ( |  | ) |

## ~ON_PolyEdgeSegment()

ON_PolyEdgeSegment::~ON_PolyEdgeSegment | ( |  | ) |

## Member Function Documentation

## Brep()

const ON_Brep* ON_PolyEdgeSegment::Brep | ( |  | ) | const

## Create() [1/2]

bool ON_PolyEdgeSegment::Create | ( | const ON_BrepTrim * | trim,
|  | const ON_UUID & | object_id
| ) |  |

## Create() [2/2]

bool ON_PolyEdgeSegment::Create | ( | const ON_Curve * | curve,
|  | const ON_UUID & | object_id
| ) |  |

## DestroyRuntimeCache()

void ON_PolyEdgeSegment::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_CurveProxy.

## DuplicateCurve()

ON_Curve* ON_PolyEdgeSegment::DuplicateCurve | ( |  | ) | const

virtual

Reimplemented from ON_CurveProxy.

## Edge()

const ON_BrepEdge* ON_PolyEdgeSegment::Edge | ( |  | ) | const

## EdgeDomain()

ON_Interval ON_PolyEdgeSegment::EdgeDomain | ( |  | ) | const

## EdgeParameter()

double ON_PolyEdgeSegment::EdgeParameter | ( | double | t | ) | const

## Face()

const ON_BrepFace* ON_PolyEdgeSegment::Face | ( |  | ) | const

## IsClosed()

ON_BOOL32 ON_PolyEdgeSegment::IsClosed | ( |  | ) | const

virtual

Reimplemented from ON_CurveProxy.

## IsoType()

ON_Surface::ISO ON_PolyEdgeSegment::IsoType | ( |  | ) | const

## Read()

ON_BOOL32 ON_PolyEdgeSegment::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_CurveProxy.

## ReversedEdgeDir()

bool ON_PolyEdgeSegment::ReversedEdgeDir | ( |  | ) | const

## ReversedTrimDir()

bool ON_PolyEdgeSegment::ReversedTrimDir | ( |  | ) | const

## Surface()

const ON_Surface* ON_PolyEdgeSegment::Surface | ( |  | ) | const

## Trim()

const ON_BrepTrim* ON_PolyEdgeSegment::Trim | ( |  | ) | const

## TrimDomain()

ON_Interval ON_PolyEdgeSegment::TrimDomain | ( |  | ) | const

## Write()

ON_BOOL32 ON_PolyEdgeSegment::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_CurveProxy.

## Friends And Related Function Documentation

## ON_PolyEdgeCurve

friend class ON_PolyEdgeCurve

friend

Definition at line 283 of file opennurbs_polyedgecurve.h.

## Member Data Documentation

## m_brep

const ON_Brep* ON_PolyEdgeSegment::m_brep

Definition at line 276 of file opennurbs_polyedgecurve.h.

## m_component_index

ON_COMPONENT_INDEX ON_PolyEdgeSegment::m_component_index

Definition at line 239 of file opennurbs_polyedgecurve.h.

## m_edge

const ON_BrepEdge* ON_PolyEdgeSegment::m_edge

Definition at line 278 of file opennurbs_polyedgecurve.h.

## m_edge_domain

ON_Interval ON_PolyEdgeSegment::m_edge_domain

Definition at line 241 of file opennurbs_polyedgecurve.h.

## m_face

const ON_BrepFace* ON_PolyEdgeSegment::m_face

Definition at line 279 of file opennurbs_polyedgecurve.h.

## m_object_id

ON_UUID ON_PolyEdgeSegment::m_object_id

Definition at line 236 of file opennurbs_polyedgecurve.h.

## m_parent_object

const void* ON_PolyEdgeSegment::m_parent_object

Definition at line 275 of file opennurbs_polyedgecurve.h.

## m_surface

const ON_Surface* ON_PolyEdgeSegment::m_surface

Definition at line 280 of file opennurbs_polyedgecurve.h.

## m_trim

const ON_BrepTrim* ON_PolyEdgeSegment::m_trim

Definition at line 277 of file opennurbs_polyedgecurve.h.

## m_trim_domain

ON_Interval ON_PolyEdgeSegment::m_trim_domain

Definition at line 243 of file opennurbs_polyedgecurve.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_polyedgecurve.h